#ifndef _DMC_LIB_H
#define _DMC_LIB_H

#ifndef TRUE
#define TRUE  1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef NULL
#ifdef  __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef float               FLOAT;

typedef unsigned char  uint8;                   /* defined for unsigned 8-bits integer variable 	޷8λͱ  */
typedef signed   char  int8;                    /* defined for signed 8-bits integer variable		з8λͱ  */
typedef unsigned short uint16;                  /* defined for unsigned 16-bits integer variable 	޷16λͱ */
typedef signed   short int16;                   /* defined for signed 16-bits integer variable 		з16λͱ */
typedef unsigned int   uint32;                  /* defined for unsigned 32-bits integer variable 	޷32λͱ */
typedef signed   int   int32;                   /* defined for signed 32-bits integer variable 		з32λͱ */
typedef unsigned long long   uint64;    
typedef signed   long long   int64; 

typedef uint32 (__stdcall * DMC3K5K_OPERATE)(void* operator_data);




#define __DMC_EXPORTS

//
#ifdef __DMC_EXPORTS
	#define DMC_API __declspec(dllexport)
#else
	#define DMC_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

//úͶȡӡģʽ
DMC_API short __stdcall dmc_set_debug_mode(WORD mode,const char* pFileName);
DMC_API short __stdcall dmc_get_debug_mode(WORD* mode,char* pFileName);


//ú
DMC_API short __stdcall dmc_board_init_eth(WORD CardNo,const char* IpAddr); 	//ʼ
DMC_API short __stdcall dmc_board_close(void);	//رտ
DMC_API short __stdcall dmc_soft_reset(WORD CardNo);//ȸλ
DMC_API short __stdcall dmc_cool_reset(WORD CardNo);//临λ



/************************/
//ģʽ		
DMC_API short __stdcall dmc_set_pulse_outmode(WORD CardNo,WORD axis,WORD outmode);	
DMC_API short __stdcall dmc_get_pulse_outmode(WORD CardNo,WORD axis,WORD* outmode);	




/*************************************˶*****************************************/
//ٶ		
DMC_API short __stdcall dmc_set_profile(WORD CardNo,WORD axis,double Min_Vel,double Max_Vel,double Tacc,double Tdec,double stop_vel);//趨ٶ߲
DMC_API short __stdcall dmc_get_profile(WORD CardNo,WORD axis,double *Min_Vel,double *Max_Vel,double *Tacc,double *Tdec,double *stop_vel);//ȡٶ߲
DMC_API short __stdcall dmc_set_s_profile(WORD CardNo,WORD axis,WORD s_mode,double s_para);//ƽٶ߲
DMC_API short __stdcall dmc_get_s_profile(WORD CardNo,WORD axis,WORD s_mode,double *s_para);//ȡƽٶ߲ DMC5800 s_modeָ뷵زֵ

//λ˶()		
DMC_API short __stdcall dmc_pmove(WORD CardNo,WORD axis,long dist,WORD posi_mode);//ָλ˶	
DMC_API short __stdcall dmc_vmove(WORD CardNo,WORD axis,WORD dir);//ٶ˶	
DMC_API short __stdcall dmc_change_speed(WORD CardNo,WORD axis,double Curr_Vel,double Taccdec);//߸ıָĵǰ˶ٶ



/************************˶*************************/	
DMC_API short __stdcall dmc_set_home_pin_logic(WORD CardNo,WORD axis,WORD org_logic,double filter);//HOMEź
DMC_API short __stdcall dmc_get_home_pin_logic(WORD CardNo,WORD axis,WORD *org_logic,double *filter);//ȡHOMEź
DMC_API short __stdcall dmc_set_homemode(WORD CardNo,WORD axis,WORD home_dir,double vel,WORD mode,WORD EZ_count);//趨ָĻԭģʽ
DMC_API short __stdcall dmc_get_homemode(WORD CardNo,WORD axis,WORD *home_dir, double *vel_mode,WORD *home_mode,WORD *EZ_count);//ȡָĻԭģʽ
DMC_API short __stdcall dmc_set_home_position(WORD CardNo,WORD axis,WORD enable,double position);//ûƫģʽ
DMC_API short __stdcall dmc_get_home_position(WORD CardNo,WORD axis,WORD *enable,double *position);//ȡƫģʽ
DMC_API short __stdcall dmc_home_move(WORD CardNo,WORD axis);//
DMC_API short __stdcall dmc_get_home_result(WORD CardNo,WORD axis,WORD* state);//ȡִ״̬




/********************ͨIO**************************/
//ͨIO
DMC_API short __stdcall dmc_read_inbit(WORD CardNo,WORD bitno);//ȡڵ״̬
DMC_API short __stdcall dmc_write_outbit(WORD CardNo,WORD bitno,WORD on_off);//ڵ״̬
DMC_API short __stdcall dmc_read_outbit(WORD CardNo,WORD bitno);//ȡڵ״̬
DMC_API DWORD __stdcall dmc_read_inport(WORD CardNo,WORD portno);//ȡ˿ڵֵ
DMC_API DWORD __stdcall dmc_read_outport(WORD CardNo,WORD portno);//ȡ˿ڵֵ
DMC_API short __stdcall dmc_write_outport(WORD CardNo,WORD portno,DWORD outport_val);//˿ڵֵ
//ӴֵĽӿ
DMC_API short __stdcall dmc_read_inbit_ex(WORD CardNo,WORD bitno,WORD *state);//ȡڵ״̬
DMC_API short __stdcall dmc_read_outbit_ex(WORD CardNo,WORD bitno,WORD *state);//ȡڵ״̬
DMC_API short __stdcall dmc_read_inport_ex(WORD CardNo,WORD portno,DWORD *state);//ȡ˿ڵֵ
DMC_API short __stdcall dmc_read_outport_ex(WORD CardNo,WORD portno,DWORD *state);//ȡ˿ڵֵ





//רIO
//ⲿλ
DMC_API short __stdcall dmc_set_el_mode(WORD CardNo,WORD axis,WORD enable,WORD el_logic,WORD el_mode);//ELź
DMC_API short __stdcall dmc_get_el_mode(WORD CardNo,WORD axis,WORD *enable,WORD *el_logic,WORD *el_mode);//ȡELź



/*********************λü***************************/
//ǰλ()
DMC_API short __stdcall dmc_set_position(WORD CardNo,WORD axis,long current_position);
DMC_API long __stdcall dmc_get_position(WORD CardNo,WORD axis);	



/**************************˶״̬********************************/
//״̬
DMC_API double __stdcall dmc_read_current_speed(WORD CardNo,WORD axis);	//ȡָĵǰٶ()
DMC_API short __stdcall dmc_check_done(WORD CardNo,WORD axis);	//ȡָ˶״̬
DMC_API DWORD __stdcall dmc_axis_io_status(WORD CardNo,WORD axis);//ȡָй˶źŵ״̬
DMC_API short __stdcall dmc_stop(WORD CardNo,WORD axis,WORD stop_mode);//ֹͣ
DMC_API short __stdcall dmc_get_axis_run_mode(WORD CardNo, WORD axis,WORD* run_mode);//ȡָ˶ģʽ
DMC_API short __stdcall dmc_get_stop_reason(WORD CardNo,WORD axis,long* StopReason);//ȡֹͣԭ
DMC_API short __stdcall dmc_clear_stop_reason(WORD CardNo,WORD axis);//ֹͣԭ


#ifdef __cplusplus
}
#endif

#endif
